                                                      (* 28.3.1997 *)
{ Quelle: David Wells:
  The Penguin Dictionary of Curious and interesting Geometry
  Penguin Books London 1991 ISBN 0-14-011813-6   Seite 53

  Die Seiten eines Polygons werden halbiert.  Das Teilungsverhaeltnis ist
  uebrigens beliebig waehlbar. Wenn man diesen Prozess iterativ durchfuehrt
  entsteht ein Polygon, dessen gegenueberliegende Seiten parallel und gleich
  lang sind. Konvergenzgeschwindigkeit ?
  Das Ausgangspolygon muss eine gerade Seitenanzahl haben. Abwechselnde
  Polygone sind ungefaehr aehnlich. Abgeleitete Polygone haben alle den
  gleichen Schwerpunkt.
  Man kann sagen dieser Prozess strebt einer Regelmaessigkeit zu.
                                                                           }

PROGRAM Polteil2;
USES CRT,GRAPH,UNIGRA12;

CONST
Eps = 1.0E-12;                            (* Eps fuer Division durch Null *)
MaxPoints = 6;                            (* Anzahl der PolygonPunkte     *)

TYPE
Polygon = ARRAY[1..MaxPoints] OF Pt2D;

VAR
PolyA,PolyE,Poly: Polygon;
Rek : INTEGER;                        (* Anzahl der abgeleiteten Polygone *)
RekS : STRING;
SeiteA    : ARRAY[1..MaxPoints] OF Vt2D;
SteigungA : ARRAY[1..MaxPoints] OF EXTENDED;
LA        : ARRAY[1..MaxPoints] OF EXTENDED;

SeiteE    : ARRAY[1..MaxPoints] OF Vt2D;
SteigungE : ARRAY[1..MaxPoints] OF EXTENDED;
LE        : ARRAY[1..MaxPoints] OF EXTENDED;

{ ------------------------- Unterprogramme ------------------------------ }
Procedure Ausgangszustand_definieren;
   BEGIN                                     (* FALSE = EGAVGA.BGI        *) 
   IF PLOT THEN Plotter_einschalten;         (* TRUE = bgi256v2.bgi       *)
   WinitGraph(0,0,'');       (* ModeNr. 3: 800x600 256 F  *)
   Weltgrenzen_festlegen(einh);              (*         4: 1024x768 256 F *)
   Viewport_festlegen;                       (* 0: 320x200 1:640x400      *)
                                             (* 2: 640x480 256 F          *)
   IF PLOT THEN GeraetefensterPlotter_festlegen;
   Parameter2D;
   IF PLOT THEN Portrait  := FALSE;        (* Querformat Bild liegend      *)
   IF PLOT THEN WRITE(AUX,'WU0');          (* width unit absolut in mm     *)
   Plast.X := WI2D[1].X;                 (* letzter Punkt initialisieren   *)
   Plast.Y := WI2D[1].Y;

   Viewport_zeichnen; 
 {  Koordinatenachsen_zeichnen;
   Gitter(0.3,2.0,10.0);}(* Strich,              klE,             grE     *)
                       (* grosse Strichlaenge,kleine Einheit, grosse Einh *)
  END;

Procedure Beschriftung;
  VAR
  T: Ttyp;
  XUntergr,XObergr,YUntergr,YObergr,einhS: STRING[Bz1];
  Ttemp1,Ttemp2: STRING[Bz2];

  BEGIN
  STR(WI2D[1].X:5:1,XUntergr); STR(WI2D[1].Y:5:1,YUntergr);
  STR(WI2D[2].X:5:1,XObergr);  STR(WI2D[2].Y:5:1,YObergr);
  STR(Einh:5:3,EinhS);
  STR(Rek:3,RekS);
(* ----------------------------- TEXTE --------------------------------- *)
  
  Ttemp1 := 'geg: beliebiges konvexes Polygon mit 2n Eckenanzahl';
  Ttemp2 := ' Jede Seite wird halbiert';
  T[1] := Ttemp1 + Ttemp2;
  Ttemp1 := 'Es werden iterativ '+ RekS +' neue Polygone gezeichnet.  ';
  Ttemp2 := 'Es entsteht ein Polygon mit ';
  T[2] := Ttemp1 + Ttemp2;
  Ttemp1 := 'paarweise parallelen gegenueberliegenden';
  Ttemp2 := ' gleichlangen Seiten';
  T[3] := Ttemp1 + Ttemp2;
        Ttemp1 := 'Weltgrenzen: X von '+XUntergr+' bis '+XObergr;
        Ttemp2 := '   Y von '+YUntergr+' bis '+YObergr;
  T[4] := Ttemp1 + Ttemp2;
  T[5] := '1 Einheit entspricht '+EinhS+'  cm';
  Text_ausgeben(T,5);                                 (* .. Texte ausgeben *)
  END;
                      (* ---------- *)

PROCEDURE MidPoint(P1,P2: Pt2D; VAR M: Pt2D);
   BEGIN
     M.X := (P1.X+P2.X)/2.0;
     M.Y := (P1.Y+P2.Y)/2.0;
   END;

PROCEDURE MakeVt2D(P1,P2: Pt2D; VAR V: Vt2D);
  BEGIN
   V.X := P2.X - P1.X;
   V.Y := P2.Y - P1.Y;
  END;

PROCEDURE LengthVt2D(V: Vt2D; VAR L: EXTENDED);
BEGIN
  L := SQRT(SQR(V.X)+SQR(V.Y)+Eps);
END;

                        (* -------- *)

PROCEDURE NormLinie;
  BEGIN
    IF PLOT THEN BEGIN
          
               WRITE(AUX,'PW0.15');          (* 0.15 mm                    *)
               WRITE(AUX,'LT');              (* solid                      *)
    END;
  SetLineStyle(0,0,1);
  END;

PROCEDURE DuenneLinie;
  BEGIN
    IF PLOT THEN BEGIN
      
               WRITE(AUX,'PW0');             (* duennste Linie             *)
               WRITE(AUX,'LT');              (* solid                      *)
    END;
  SetLineStyle(0,0,1);
  END;

PROCEDURE HilfsLinie2;
  BEGIN
    IF PLOT THEN BEGIN
          {    WRITE(AUX,'PW0.3');       }    (* staerkere Hilfslinie      *)
          {    WRITE(AUX,'LT1,0.8,1');   }    (* hellgrau length 1.0 mm    *)
               WRITE(AUX,'WU0');
               WRITE(AUX,'PW0.2');
               WRITE(AUX,'UL8,2,7,2,7,2,7');
               WRITE(AUX,'LT8,2.0,1');      
    END;
    SetLineStyle(1,0,1);
  END;




PROCEDURE DickeLinie;
  BEGIN
    IF PLOT THEN BEGIN
               WRITE(AUX,'UL');              (* 7.:                        *)
               WRITE(AUX,'PW0.3');           (* 0.3 durchgehend            *)
               WRITE(AUX,'LT');
    END;
    SetLineStyle(0,0,1);
  END;
   
(* -------------------- eigentliche Routinen ----------------------------- *)

PROCEDURE Eingabe;                
  BEGIN
   PolyA[1].X := -18.4;  PolyA[1].Y :=   3.4;
   PolyA[2].X := -10.6;  PolyA[2].Y := -19.2;
   PolyA[3].X :=  17.1;  PolyA[3].Y := -12.5;
   PolyA[4].X :=  19.7;  PolyA[4].Y :=  23.4;
   PolyA[5].X :=  13.8;  PolyA[5].Y :=  35.1;
   PolyA[6].X :=  -3.8;  PolyA[6].Y :=  28.4;
  END;

PROCEDURE DivPolygon(Polyin : Polygon; VAR Polyout:Polygon);
   VAR
   I: INTEGER;
   BEGIN
     FOR I := 1 TO MaxPoints-1 DO BEGIN
       MidPoint(Polyin[I],Polyin[I+1],Polyout[I]);
     END;
     MidPoint(Polyin[MaxPoints],Polyin[1],Polyout[MaxPoints]);
   END;

PROCEDURE ZeichnePolygon(Poly:Polygon;Col:INTEGER);
  VAR
  I: INTEGER;
  
  H: Pt2D;                      (* Hilfspunkt nur fuers Zeichnen am Schirm *)
  Delta : EXTENDED;
  BEGIN
  Delta := 0.5;
  H.X := Poly[1].X + Delta;  H.Y := Poly[1].Y+delta;
  MovetoPt2D(Poly[1]);
  FOR I := 2 TO MaxPoints DO BEGIN
    DrawtoPt2D(Poly[I],Col);
  END;
  DrawtoPt2D(Poly[1],Col);
  MovetoPt2D(H);
END;

PROCEDURE Polygonfam;
  VAR
  I: INTEGER;
  Col1,Col2: INTEGER;
  BEGIN
    Col1 := 14; Col2 := 15;
    ZeichnePolygon(PolyA,15);   
    DivPolygon(PolyA,Polye);
    FOR I := 1 TO Rek DO BEGIN
      IF Col = Col1 THEN BEGIN
        Col := Col2;
        IF PLOT THEN DuenneLinie; END ELSE BEGIN
          Col := Col1;
          IF PLOT THEN Hilfslinie2;
        END;
      ZeichnePolygon(Polye,Col);
      DivPolygon(Polye,Polye);
    END;
 END;

PROCEDURE AnfEndPolygon;
  VAR
  I: INTEGER;
  BEGIN
    FOR I := 1 TO MaxPoints-1 DO BEGIN
      MakeVt2D(PolyA[I],PolyA[I+1], SeiteA[I]);
      MakeVt2D(PolyE[I],PolyE[I+1], SeiteE[I]);
    END;
    MakeVt2D(PolyA[MaxPoints],PolyA[1], SeiteA[Maxpoints]);
    MakeVt2D(PolyE[MaxPoints],PolyE[1], SeiteE[Maxpoints]);
    FOR I := 1 TO MaxPoints DO BEGIN
      LengthVt2D(SeiteA[I],LA[I]);
      LengthVt2D(SeiteE[I],LE[I]);
    END;
  END;

PROCEDURE Seiten;
  VAR
  I: INTEGER;
BEGIN
    FOR I := 1 TO MaxPoints DO BEGIN
      IF ABS(SeiteA[I].X) > Eps THEN BEGIN
        SteigungA[I] := SeiteA[I].Y/SeiteA[I].X;
      END ELSE SteigungA[I] := 9.99999999E25;
    END;
    FOR I := 1 TO MaxPoints DO BEGIN
      IF ABS(SeiteE[I].X) > Eps THEN BEGIN
        SteigungE[I] := SeiteE[I].Y/SeiteE[I].X;
      END ELSE SteigungE[I] := 9.99999999E25;
    END;

    WRITELN;
    WRITELN('Werte des Anfangspolygons:');
    WRITELN;
    FOR I := 1 TO MaxPoints DO BEGIN
      WRITE('Seite Nr.:',I:2,'  Laenge: ',LA[I]:14:6);
      WRITELN('  Steigung:  ',SteigungA[I]:14:6);
    END;
    WRITELN;
    WRITELN('Werte des '+ RekS + '.ten abgeleiteten Polygons:');
    WRITELN;
    FOR I := 1 TO MaxPoints DO BEGIN
      WRITE('Seite Nr.:',I:2,'  Laenge: ',LE[I]:14:6);
      WRITELN('  Steigung:  ',SteigungE[I]:14:6);
    END;

    IF Plot THEN BEGIN
    WRITELN(AUX,' ');
    WRITELN(AUX,'Werte des Anfangspolygons:');
    WRITELN(AUX,' ');
    FOR I := 1 TO MaxPoints DO BEGIN
      WRITE(AUX,'Seite Nr.:',I:2,'  Laenge: ',LA[I]:14:6);
      WRITELN(AUX,'  Steigung:  ',SteigungA[I]:14:6);
    END;
    WRITELN(AUX,' ');
    WRITELN(AUX,'Werte des '+ RekS + '.ten abgeleiteten Polygons:');
    WRITELN(AUX,' ');
    FOR I := 1 TO MaxPoints DO BEGIN
      WRITE(AUX,'Seite Nr.:',I:2,'  Laenge: ',LE[I]:14:6);
      WRITELN(AUX,'  Steigung:  ',SteigungE[I]:14:6);
    END;
  WRITE(AUX,#27#69);                 (* Drucker ruecksetzen                *)
  END;
READLN;
END;

{ --------------------------- Hauptprogramm ------------------------------- }
BEGIN
  Plot := false;
  IF PLOT THEN Schnittstelle_waehlen(1);   (* 2 bedeutet auf Datei plotten *)
                                           (* 1 ist parallele Schnittst    *)
                 (* 1 Einheit auf der X-Achse und Y-Achse entspricht .. cm *)
  Einh := 0.35;
  WI2D[1].X := -40.0;  WI2D[1].Y := -20.0;
                                               (* linker unterer Punkt     *)
                                               (* des Weltfensters         *)
  Ausgangszustand_definieren;                 (* Graphikgrundeinstellung   *)
  Eingabe;
  Rek := 25;         (* Rekursionstiefe = Anzahl der abgeleiteten Polygone *)
  Beschriftung;
  Polygonfam;
  WClosegraph;
  AnfEndPolygon;
  Seiten;
END.