
UNIT UNIGRA12;  (* nach Endl *)
    (* 23.August 1996 Col beim DrawLine2d Befehl *)
 (* 1 PlotUnit entspricht 0.025 mm Handbuch HP III p *)
 (* daraus fogt:  1 mm entspricht 40 plu             *)

{$IFDEF CPU87} {$N+} {$ELSE} {$N-} {$ENDIF}

INTERFACE

USES Crt,Graph;

{$IFNDEF CPU87} TYPE EXTENDED = REAL; {$ENDIF}
CONST
NText = 10;
Bz1 = 10;        (* Buchstabenzahl fuer in Strings gewandelte Variablen *)
Bz2 = 80;        (* Buchstabenzahl fuer Ausgabestrings                  *)
TYPE

{=====2D===================================================================}

  Pt2DInt = RECORD                                                   
              X,Y: INTEGER;
            END;
  Interval2DInt = ARRAY[1..2] OF Pt2DInt;                            
  
  Pt2D = RECORD                                                       
             X,Y: EXTENDED;
         END;
  Vt2D=Pt2D;  
  Interval2D = ARRAY[1..2] OF Pt2D;                                   
  Ttyp = ARRAY[1..NText] OF STRING[Bz2];
{-----Screen---------------------------------------------------------------}

  PtScr = Pt2DInt;                                                     
  IntervalScr = Interval2DInt;                                         

{-----Plotter--------------------------------------------------------------}

  PtPlt = Pt2DInt;                                                     
  IntervalPlt = ARRAY[1..2] OF PtPlt;                                  

{-----Clipping-------------------------------------------------------------}

  edge = (Left,Right,Bottom,Top);                    (* Mengendefinition *)
  outcode = SET OF edge;
{--------------------------------------------------------------------------}
VAR

  Din,Col: Integer;               (* Din = 4 bedeutet A4 Format          *)
  Plot,Portrait: BOOLEAN;         (* Plot = False bedeutet kein Plotter  *)
                                  (* Portrait = true aufrechtes Hochfor- *)
                                  (* mat, sonst liegendes Querformat.    *)
  Aux: TEXT;                      (* Aux = Pascalinterner = logischer    *)
                                  (* Dateiname von einem logischen File  *)
                                  (* vom  Typ Text.                      *)
  PltFileName: STRING;            (* Dateiname, falls auf File geplottet *)
  GraphDriver,GraphMode : INTEGER;
  PathtoDriver : STRING;
  einh       : EXTENDED;       (* Skalierungsfaktor fuer cm genaue Plots *)
  ScrFac: EXTENDED;
  
  IScr,IScr2D: IntervalScr;         (* IScr = benutzte Bildschirmbe-      *)
                                    (* grenzung. IScr2D = umgerechnetes   *)
                                    (* Weltintervall, also tatsaechlicher *)
                                    (* Viewport beides Ganzzahlintervalle *)
  MaxXScr,MaxYScr,MaxColor: INTEGER;(* Hardwarekoordinaten des Schirms    *)     
  ScrO: Pt2D;                       (* Ursprung in Gleitkomma !           *)
  ScrU: Vt2D;                       (* Umrechnungsfaktor ScrU.X ScrU.Y    *)
                                    (* Screenfaktor ist beruecksichtigt   *)
  IPlt,IPlt2D: IntervalPlt;         (* IPlt = Hardwareintervall des Plot- *)
                                    (* ters. IPlt2D umgerechnetes Welt-   *)
                                    (* fenster auf Plotter abgebildet     *)
  MaxXPlt,MaxYPlt: Integer;         (* Hardwarekoordinaten des Plotters   *)
  PltO: Pt2D;                       (* Plotterursprung in Gleitkomma !    *)
  PltU: Vt2D;                       (* Plotterumrechnungsfaktor           *)
                                    (* PltU.X = PltU.Y                    *)
  WI2D: Interval2D;                 (* Weltintervall *)
  XL,YL: EXTENDED;                  (* Weltintervallausdehnung *) 
  Plast : Pt2D;                     (* Speicher fuer den letzten gerade   *)
                                    (* gezeichneten Punkt                 *)
  Clipival: Interval2D;             (* Clippintervall                     *)
  zeich: BOOLEAN;                   (* Schalter ob gezeichnet werden soll *)
{-----Generals-------------------------------------------------------------}
PROCEDURE WaitforKey;
FUNCTION  Null(Z,Epsilon: EXTENDED): BOOLEAN;                        
PROCEDURE WinitGraph(DriverNr,ModeNr: INTEGER; PathtoDr: STRING);
PROCEDURE WCloseGraph;
{==========================================================================}
Procedure Graphik_einschalten(Pfad: STRING);
Procedure Schnittstelle_waehlen(Device:INTEGER);
Procedure DruckerHPIIIp_als_Plotter;
Procedure Plotter_einschalten;
Procedure Weltgrenzen_festlegen(einh: EXTENDED);
Procedure Viewport_festlegen;
Procedure GeraetefensterPlotter_festlegen;
Procedure Viewport_zeichnen;
Procedure Koordinatenachsen_zeichnen;
Procedure Gitter(Strich,klE,grE: REAL);
Procedure Text_ausgeben(T:Ttyp; NText:Integer);
PROCEDURE CompOutCode(X,Y:EXTENDED; VAR code: outcode;Clipival: Interval2D);
PROCEDURE CsClip(VAR P1,P2: Pt2D; Clipival: Interval2D;VAR zeich: BOOLEAN);
{===========================================================================}
{-----Screen---------------------------------------------------------------}
PROCEDURE PutPtScr(PScr: PtScr; Col: INTEGER);                        
PROCEDURE MoveToPtScr(PScr: PtScr);                                   
PROCEDURE DrawToPtScr(PScr: PtScr; Col: INTEGER);                     
PROCEDURE DrawIntervalScr(IScr: IntervalScr; Col: INTEGER);
{-----Plotter--------------------------------------------------------------}
PROCEDURE InitializePlotter;
PROCEDURE PutPtPlt(PPlt: PtPlt; Col: INTEGER);                        
PROCEDURE MoveToPtPlt(PPlt: PtPlt);                                    
PROCEDURE DrawToPtPlt(PPlt: PtPlt; Col: INTEGER);                      
PROCEDURE DrawIntervalPlt(IPlt: IntervalPlt; Col: INTEGER);           
PROCEDURE OutTextXY2D(P:Pt2D; S : STRING);  
{-----Transformation-------------------------------------------------------}
PROCEDURE ParameterTransformationScr;                                  
PROCEDURE ParameterTransformationPlt;                                  
PROCEDURE Transformation(P: Pt2D; VAR PScr: PtScr; VAR PPlt: PtPlt);   
PROCEDURE Parameter2D;
{-----Draw-----------------------------------------------------------------}
PROCEDURE PutPt2D(P: Pt2D; Col: INTEGER);
PROCEDURE MoveToPt2D(P: Pt2D);
PROCEDURE DrawToPt2D(P: Pt2D; Col: INTEGER);
PROCEDURE DrawLine2D(P1:Pt2D;P2:Pt2D;Col:INTEGER);
PROCEDURE DrawInterval2D(I2D: Interval2D; Col: INTEGER);
PROCEDURE MoveRel2D(V: Vt2D);
PROCEDURE DrawRel2D(V: Vt2D; Col: INTEGER);
(* ====================================================================== *)

IMPLEMENTATION

{-----Generals------------------------------------------------------------}

PROCEDURE WaitforKey;
 (* Diese Routine wartet nur auf einen Tastendruck von der Tastatur  *)
 (* Zuerst wird der Tastaturpuffer geleert, um sicherzustellen, dass *)
 (* nicht in der Zwischenzeit eine Taste gedrueckt wurde.            *)
  Var a: CHAR;
  Begin
    WHILE KEYPRESSED DO  Begin
     A:= READKEY;
    End; 
   REPEAT
   UNTIL KEYPRESSED;
   A := READKEY;
  END;

FUNCTION Null(Z,Epsilon: EXTENDED): BOOLEAN;
BEGIN
  Null:=ABS(Z)<Epsilon;
END;

PROCEDURE WINITGRAPH(DriverNr,ModeNr:INTEGER;PathtoDr:STRING);
VAR
XAsp,YAsp                 : WORD;
  BEGIN
  GraphDriver  := DriverNr;
  GraphMode    := ModeNr;
  PathtoDriver := PathtoDr;
  DetectGraph(GraphDriver,GraphMode);
  InitGraph(GraphDriver,GraphMode,PathtoDriver);
  MaxXScr      := GetMaxX;
  MaxYScr      := GetMaxY;
  GetAspectRatio(XAsp,YAsp);
  ScrFac       := XAsp/YAsp;
  MaxColor     := GetMaxColor;
  ClearDevice;
  END;

PROCEDURE InitializePlotter;
BEGIN
IF Plot THEN                      (* Schalter fuer Plotter            *)
   BEGIN
      Din := 4;                   (* A4 Format                        *)

                                      (* IN = initialize              *)
 (* IP legt Skalierungspunkte neu fest fuer A4 P1(603/521)            *)
 (* und P2(10603/7721)  durch IN auch initialisiert auf Defaultwert   *)
 (* VS = velocity select Geschwindigkeit                              *)
 (* IW = input window Zeichnungsfenster mit Punkt links unten und     *)
 (* Punkt rechts oben                                                 *)
 (* SP1 = select pen unbedingt, sonst keine Reaktion                  *)

    Write (AUX,'IN;IP;IW;VS20;SP1');
    CASE Portrait OF
      FALSE : BEGIN                    (* liegendes  Bild  *)
               Write(Aux,'RO90');
              CASE Din OF
                  4: BEGIN MaxXPlt:=10860;  MaxYPlt:=7910; END;
                     (* HPLaserjetIIIp *)
                  3: BEGIN MaxXPlt:=10870; MaxYPlt:=15970; END;      
              END;
            END;
       TRUE : BEGIN                    (* aufrechtes Bild   *)
               CASE Din OF
                  4: BEGIN MaxXPlt:=7910; MaxYPlt:=10860; END;
                     (* HPLaserjetIIIp *)
                  3: BEGIN MaxXPlt:=15970; MaxYPlt:=10870; END;
               END;
             END;
    END;
  END;
END;

PROCEDURE WCloseGraph;
BEGIN
  IF Plot THEN
       BEGIN
                WRITE(AUX,'SP0;'); (* SP0 bedeutet, dass der             *)
                                   (* Plotter legt Stift ab ohne einen   *)
                                   (* neuen zu holen                     *)
                write(AUX,#27#69); (* Drucker ruecksetzen                *)
  END;
  SETCOLOR(8);
  LINE(MaxXScr-10,MaxYScr-10,MaxXScr-10,MaxYScr-30);
  LINE(MaxXScr-10,MaxYScr-30,MaxXScr-30,MaxYScr-30);
  LINE(MaxXScr-30,MaxYScr-30,MaxXScr-30,MaxYScr-10);
  LINE(MaxXScr-30,MaxYScr-10,MaxXScr-10,MaxYScr-10);
  LINE(MaxXScr-10,MaxYScr-10,MaxXScr-30,MaxYScr-30);
  LINE(MaxXScr-30,MaxYScr-10,MaxXScr-10,MaxYScr-30);
  Waitforkey;
  Closegraph;
END;

Procedure Graphik_einschalten(Pfad: STRING);
   BEGIN
    WINITGRAPH(0,0,Pfad); 
   END;

 Procedure Schnittstelle_waehlen(Device:INTEGER);
  BEGIN
   CASE Device OF
    0: Assign(AUX,'COM1');         {serial}
    1: Assign(AUX,'Lpt1');         {parallel}
    2: BEGIN                       {Datei}
      CLRSCR;
      WRITELN; WRITELN;
      WRITELN(' Geben Sie Pfad und Name mit Erweiterung der Plotdatei ein:');
      WRITE(' z.B.: A:\logar1.dat:   ');      (* Device muss 2,  Plot muss *)
      READLN(PltFileName);                    (* true sein, dann wird auf  *)
                                              (* eine Datei geplottet.     *)
      Assign(Aux,PltFileName);                (* auf Datei plotten         *)
       END;
   END;
  REWRITE(AUX);
  END;

 Procedure DruckerHPIIIp_als_Plotter;
 BEGIN
  WRITE(AUX,#27#69);                   (* Drucker ruecksetzen              *)
  WRITE(AUX,#27#37#48#66);             (* HPGL/2 Modus einschalten         *)
 END;

  Procedure Plotter_einschalten;
  BEGIN
   IF Plot THEN
     BEGIN
      DruckerHPIIIp_als_Plotter;
      InitializePlotter;
   END;
  END;

  Procedure Weltgrenzen_festlegen(einh: EXTENDED);
  CONST
  mass = 9.85;   (* Die Seite des groesstmoeglichen Quadrats wurde bei    *)
                 (* einem symmetrischen, aber beliebigen Weltfenster am   *)
                 (* Papier abgemessen, durch 2 dividiert und als neue     *)
                 (* vorlaeufige Weltgrenzen eingesetzt. Die neuen vom     *)
                 (* Benutzer definierten Weltgrenzen duerfen nur mit      *)
                 (* einem Proportionalitaetsfaktor gewaehlt werden.       *)
                 (* Die Raender des Weltfensters sind noch immer belie-   *)
                 (* bige Werte.                                           *)
  VAR         
  fakx,faky,d,Plv: EXTENDED;
  Begin
  Plv := 7910/10860;        (* Plv = Plotterverhaeltnis Hoehe zu Laenge *)
  fakx := mass/(einh*Plv);
  faky := mass/einh;
  (* Weltfenstergroessen werden vorgegeben *)
  XL  :=  2*fakx;  YL  :=  2*faky;
  (* zweiter Punkt rechts oben wird vom Programm berechnet *)
  WI2D[2].X := XL + WI2D[1].X;  WI2D[2].Y  :=  YL +  WI2D[1].Y;
  Clipival[1].X := WI2D[1].X; Clipival[1].Y := WI2D[1].Y;
  Clipival[2].X := WI2D[2].X; Clipival[2].Y := WI2D[2].Y;
  End;


  Procedure Viewport_festlegen;
  BEGIN
  (* erster Punkt links unten *)   (* Y wird von oben herunter gezaehlt! *)
  IScr[1].X := 0;    IScr[1].Y := 479; 
  (* zweiter Punkt rechts oben *)
  IScr[2].X := 639;  IScr[2].Y := 0;          
  (* Ein Fenster ist ein anderer Name fuer Intervall. Es ist immer ein   *)
  (* Rechteck. Es ist ein Array mit zwei Elementen( = 2 Punkte )         *)
  (* Der Viewport wird in Pixel festgelegt, der Koordinatenursprung des  *)
  (* Schirms liegt links oben. Der erste Intervallpunkt wie bei allen    *)
  (* Intervallen, jedoch links unten.                                    *)
  (* Hier ist der ganze VGA Schirm der Viewport                          *)
  END;

  Procedure GeraetefensterPlotter_festlegen;
  BEGIN
  (* erster Punkt links unten *)   (* Y wird von unten hinauf gezaehlt!  *)
  IPlt[1].X := 0;  IPlt[1].Y := 0;
  (* zweiter Punkt rechts oben *)
  IPlt[2].X := MaxXPlt;  IPlt[2].Y := MaxYPlt;   (* 7910  10860 HP IIIp   *)
  (* Eingabe erfolgt in Plotterhardwarekoordinaten                        *)
  (* Der ganze zur Verfuegung stehende Raum ist ausgenuetzt.              *)
  END;

  Procedure Viewport_zeichnen;
  BEGIN
   Col := 8;
   IF Plot THEN  WRITE(AUX,'PW0.1');  (* duenner Strich              *)
   DrawInterval2D(WI2D,Col);   (* Weltgrenzen  = Viewport gezeichnet *)
   IF Plot THEN  WRITE(AUX,'PW');     (* Default Strichstaerke       *)
  END;

  Procedure Koordinatenachsen_zeichnen;
  VAR
  P    : Pt2D;
  PScr : PtScr;
  PPlt : PtPlt;
  BEGIN
   IF PLOT THEN WRITE(AUX,'PW0.1');               (*  duenner Strich       *)
   Col := 8;
   P.X:=WI2D[1].X; P.Y:=0.0;                                (* X-Achse     *)
   Transformation(P,PScr,PPlt);              (* in: P      out: PScr,PPlt  *)
   MoveToPtScr(PScr);           IF Plot THEN MoveToPtPlt(PPlt);
   P.X:=WI2D[2].X; P.Y:=0.0;
   Transformation(P,PScr,PPlt);
   DrawToPtScr(PScr,Col);       IF Plot THEN DrawToPtPlt(PPlt,Col);
   P.X:=0.0; P.Y:=WI2D[1].Y;                                (* Y-Achse     *)
   Transformation(P,PScr,PPlt);
   MoveToPtScr(PScr);           IF Plot THEN MoveToPtPlt(PPlt);
   P.X:=0.0; P.Y:=WI2D[2].Y;
   Transformation(P,PScr,PPlt);
   DrawToPtScr(PScr,Col);       IF Plot THEN DrawToPtPlt(PPlt,Col);
                                           (* Koordinatenachsen gezeichnet *)
   IF Plot THEN  WRITE(AUX,'PW');          (* Default Strichstaerke        *)
  END;

  Procedure Gitter(Strich,klE,grE: REAL);
  VAR
  Strichverhaeltnis : REAL;
  EPS  : REAL;
  P    : Pt2D;
  PScr : PtScr;
  PPlt : PtPlt;
  grStrich,klStrich: REAL;
  
  BEGIN
  EPS := 1.0E-3;
  Strichverhaeltnis := 1.0/3.0;
   IF PLOT THEN WRITE(AUX,'PW0.1');                     (* duenner Strich *)
   klStrich := Strich* Strichverhaeltnis;
   Col := 7;
   P.X := 0.0; 
   WHILE P.X < WI2D[2].X- EPS DO BEGIN                 (* positive X-Achse *)
     P.Y := -Strich;                                   (* grosse Striche   *)
     Transformation(P,PScr,PPlt);
     MoveToPtScr(PScr); IF Plot THEN MoveToPtPlt(PPlt);
     P.Y := Strich;
     Transformation(P,PScr,PPlt);
     DrawToPtScr(PScr,Col);       IF Plot THEN DrawToPtPlt(PPlt,Col);
     P.X := P.X + grE;
   END;
   P.X := 0.0;
   WHILE P.X < WI2D[2].X- EPS DO BEGIN                (* positive X-Achse *)
     P.Y := -klStrich;                                (* kleine Striche   *)
     Transformation(P,PScr,PPlt);
     MoveToPtScr(PScr); IF Plot THEN MoveToPtPlt(PPlt);
     P.Y := klStrich;
     Transformation(P,PScr,PPlt);
     DrawToPtScr(PScr,Col);       IF Plot THEN DrawToPtPlt(PPlt,Col);
     P.X := P.X + klE;
   END;   
   P.X := 0.0;
   WHILE P.X > WI2D[1].X+EPS DO BEGIN                 (* negative X-Achse *)
     P.Y := - Strich;                                 (* grosse Striche   *)
     Transformation(P,PScr,PPlt);
     MoveToPtScr(PScr); IF Plot THEN MoveToPtPlt(PPlt);
     P.Y := Strich;
     Transformation(P,PScr,PPlt);
     DrawToPtScr(PScr,Col);       IF Plot THEN DrawToPtPlt(PPlt,Col);
     P.X := P.X - grE;
   END;
   P.X := 0.0;
   WHILE P.X > WI2D[1].X+ EPS DO BEGIN                (* negative X-Achse *)
     P.Y := -klStrich;                                (* kleine Striche   *)
     Transformation(P,PScr,PPlt);
     MoveToPtScr(PScr); IF Plot THEN MoveToPtPlt(PPlt);
     P.Y := klStrich;
     Transformation(P,PScr,PPlt);
     DrawToPtScr(PScr,Col);       IF Plot THEN DrawToPtPlt(PPlt,Col);
     P.X := P.X - klE;
   END;
   P.Y :=  0.0;
   WHILE P.Y < WI2D[2].Y - EPS DO BEGIN               (* positive Y-Achse *)
     P.X := - Strich;                                 (* grosse Striche   *)
     Transformation(P,PScr,PPlt);
     MoveToPtScr(PScr); IF Plot THEN MoveToPtPlt(PPlt);
     P.X := Strich;
     Transformation(P,PScr,PPlt);
     DrawToPtScr(PScr,Col);       IF Plot THEN DrawToPtPlt(PPlt,Col);
     P.Y := P.Y + grE;
   END;
   P.Y :=  0.0;
   WHILE P.Y < WI2D[2].Y - EPS DO BEGIN               (* positive Y-Achse *)
     P.X := - klStrich;                               (* kleine Striche   *)
     Transformation(P,PScr,PPlt);
     MoveToPtScr(PScr); IF Plot THEN MoveToPtPlt(PPlt);
     P.X := klStrich;
     Transformation(P,PScr,PPlt);
     DrawToPtScr(PScr,Col);       IF Plot THEN DrawToPtPlt(PPlt,Col);
     P.Y := P.Y + klE;
   END;      
   P.Y :=  0.0;
   WHILE P.Y > WI2D[1].Y + EPS DO BEGIN               (* negative Y-Achse *)
     P.X := - Strich;                                 (* grosse Striche   *)
     Transformation(P,PScr,PPlt);
     MoveToPtScr(PScr); IF Plot THEN MoveToPtPlt(PPlt);
     P.X := Strich;
     Transformation(P,PScr,PPlt);
     DrawToPtScr(PScr,Col);       IF Plot THEN DrawToPtPlt(PPlt,Col);
     P.Y := P.Y - grE;
   END;
   P.Y :=  0.0;
   WHILE P.Y > WI2D[1].Y + klStrich DO BEGIN          (* negative Y-Achse *)
     P.X := - klStrich;                               (* kleine Striche   *)
     Transformation(P,PScr,PPlt);
     MoveToPtScr(PScr); IF Plot THEN MoveToPtPlt(PPlt);
     P.X := klStrich;
     Transformation(P,PScr,PPlt);
     DrawToPtScr(PScr,Col);       IF Plot THEN DrawToPtPlt(PPlt,Col);
     P.Y := P.Y - klE;
   END;
   IF Plot THEN  WRITE(AUX,'PW');                (* Default Strichstaerke *)
   Col := 15;                             
  END;

  Procedure Text_ausgeben(T:Ttyp; NText:Integer);
  VAR
  PPlt: PtPlt;  PText : Pt2DInt;
  DYS,DYScr,DYP,DYPltr,lmScr,plZeile,lmPl,I : INTEGER;
  BEGIN
  lmScr := 1;                 (* lmScr = left margin Screen *)
  DYScr := 0;                 (* absoluter Zeilenwert in Pixel *)
  DYS := 10;                  (* Zeilenhoehe in SreenPixel *)
  IF PLOT THEN
    BEGIN
     lmPl := 20;                          (* lmPl = left margin Plotter in *)
                                          (* absoluten Plotterunits        *)
     plZeile := 140;                      (* plZeile = Plotterzeilenhoehe  *)
     DYPltr := MaXYPlt - plZeile;         
     WRITE(AUX,'SI,0.09,0.2');            (* Size Schriftgroesse klein     *)
    END;
  SETCOLOR(15);                           (* weisse Schrift *)
  FOR I := 1 TO NText DO
   BEGIN
     PText.X := lmScr;
     PText.Y := DYScr;
     OutTextXY(PText.X,PText.Y,T[I]);
     DYScr := DYScr + DYS;                  (* weiterschalten  Screenzeile *)
     IF PLOT THEN
       BEGIN
         PPlt.X := lmPl; PPlt.Y := DYPltr;
         MovetoPtPlt(PPlt);
         WRITE(Aux,'LB',T[I],Chr(3),';');
         DYPltr := DYPltr - plZeile;        (* weiterschalten Plotterzeile *)
       END;
   END;
  END;

(* -------------------------------------------------------------------- *)
PROCEDURE CompOutCode(X,Y:EXTENDED; VAR code: outcode;Clipival: Interval2D);
    (* Compute outcode for the point x,y *)
    (* Das Plus ist ein Mengenoperator und bedeutet Vereinigung *)
    BEGIN
    code := [];                                            (* leere Menge *)
    IF Y > Clipival[2].Y THEN code := [TOP]
    ELSE IF Y < Clipival[1].Y THEN code := [BOTTOM];
    IF X > Clipival[2].X THEN code := code + [RIGHT]
    ELSE IF X < Clipival[1].X THEN code := code + [LEFT]
    END;
               

PROCEDURE CsClip(VAR P1,P2: Pt2D; Clipival: Interval2D;VAR zeich: BOOLEAN);
                   
  VAR
  X,Y,X0,Y0,X1,Y1,XMin,YMin,XMax,YMax: EXTENDED;
  accept,done: BOOLEAN;
  outcode0, outcode1, outcodeOut: outcode;
(* Outcodes for P0,P1, and whichever point lies outside the clip rectangle *)

  BEGIN
    X0 := P1.X; Y0 := P1.Y; X1 := P2.X; Y1 := P2.Y;
    XMin := Clipival[1].X; YMin := Clipival[1].Y;
    XMax := Clipival[2].X; YMax := Clipival[2].Y;
    accept := FALSE; done := FALSE; zeich := TRUE;
    CompOutCode(X0,Y0,outcode0,Clipival);
    CompOutCode(X1,Y1,outcode1,Clipival);
    REPEAT
      IF (outcode0 = []) AND (outcode1 = []) THEN    (* trivial accept and *)
        BEGIN accept := TRUE; done := TRUE ;  END   (* exit *)
      ELSE IF (outcode0*outcode1) <> [] THEN
        BEGIN done := TRUE ; zeich := false; END
            (* logical intersection is true, so trivial reject *)
                        (* and exit *)
      ELSE
        (* failed both tests, so calculate the line segment to clip: *)
        (* from an outside point to an intersection with clip edge.  *)
        BEGIN
        (* At least one endpoint is outside the clip rectangle: pick it *)
        IF outcode0 <> [] THEN
          outcodeOut := outcode0 ELSE outcodeOut := outcode1;
        (* Now find intersection point *)
        (* use formulas y = y0 + slope*(x-x0)       *)
        (*              x = x0 + (1/slope)*(y-y0)   *)
        IF TOP IN outcodeOut THEN
          BEGIN                   (* divide line at top of clip rectangle *)
          X := X0 + (X1 - X0)*(YMax - Y0)/(Y1 - Y0);
          Y := YMax
          END
        ELSE IF BOTTOM IN outcodeOut THEN
          BEGIN                (* divide line at bottom of clip rectangle *)
          X := X0 + (X1 - X0)*(YMin - Y0)/(Y1 - Y0);
          Y := YMin
        END
        ELSE IF RIGHT IN outcodeOut THEN
          BEGIN            (* divide line at right edge of clip rectangle *)
          Y := Y0 + (Y1 - Y0)*(XMax - X0)/(X1 - X0);
          X := XMax
          END
        ELSE IF LEFT IN outcodeOut THEN
          BEGIN             (* divide line at left edge of clip rectangle *)
          Y := Y0 + (Y1 - Y0)*(XMin -X0)/(X1 - X0);
          X := XMin
          END;
        (* Now we must move outside point to intersection point to clip, *)
        (* and get ready for next pass                                   *)
        IF (outcodeOut = outcode0) THEN
          BEGIN
          P1.X := X; P1.Y := Y; CompOutCode(P1.X,P1.Y,outcode0,Clipival);
          END
        ELSE
          BEGIN
          P2.X := X; P2.Y := Y; CompOutCode(P2.X,P2.Y,outcode1,Clipival);
          END
      END    (* subdivide *)
    UNTIL done;
  END;  
  
{-----Screen---------------------------------------------------------------}



PROCEDURE PutPtScr(PScr: PtScr; Col: INTEGER);
BEGIN
  PutPixel(PScr.X,PScr.Y,Col);
END;

PROCEDURE MoveToPtScr(PScr: PtScr);
BEGIN
  MoveTo(PScr.X,PScr.Y);
END;

PROCEDURE DrawToPtScr(PScr: PtScr; Col: INTEGER);
BEGIN
  SetColor(Col);
  LineTo(PScr.X,PScr.Y);
END;

PROCEDURE DrawIntervalScr(IScr: IntervalScr; Col: INTEGER);
VAR PScr3,PScr4: PtScr;
BEGIN
  PScr3.X:=IScr[2].X; PScr3.Y:=IScr[1].Y;
  PScr4.X:=IScr[1].X; PScr4.Y:=IScr[2].Y;
  MoveToPtScr(IScr[1]);
  DrawToPtScr(PScr3,Col);
  DrawToPtScr(IScr[2],Col);
  DrawToPtScr(PScr4,Col);
  DrawToPtScr(IScr[1],Col);
END;

{------Plotter-------------------------------------------------------------}

PROCEDURE PutPtPlt(PPlt: PtPlt; Col: INTEGER);
BEGIN
  WRITE (AUX,'SP',Col,';');
  WRITE (AUX,'PU;PA',PPlt.X,',',PPlt.Y,';');
  WRITE (AUX,'PD',';');
END;

PROCEDURE MoveToPtPlt(PPlt: PtPlt);
BEGIN
  WRITE (AUX,'PU;PA',PPlt.X,',',PPlt.Y,';');
END;

PROCEDURE DrawToPtPlt(PPlt: PtPlt; Col: INTEGER);
BEGIN
  WRITE (AUX,'SP',Col,';');
  WRITE (AUX,'PD;PA',PPlt.X,',',PPlt.Y,';');
END;

PROCEDURE DrawIntervalPlt(IPlt: IntervalPlt; Col: INTEGER);
VAR PPlt3,PPlt4: PtPlt;
BEGIN
  PPlt3.X:=IPlt[2].X; PPlt3.Y:=IPlt[1].Y;
  PPlt4.X:=IPlt[1].X; PPlt4.Y:=IPlt[2].Y;
  MoveToPtPlt(IPlt[1]);
  DrawToPtPlt(PPlt3,Col);
  DrawToPtPlt(IPlt[2],Col);
  DrawToPtPlt(PPlt4,Col);
  DrawToPtPlt(IPlt[1],Col);
  Write(Aux,'PU');
END;

PROCEDURE OutTextXY2D(P:Pt2D; S: STRING);
VAR
 PScr: PtScr;
 PPlt: PtPlt;
 X,Y : INTEGER;
  BEGIN
    Transformation(P, PScr,PPlt);
    X := PScr.X; Y := PScr.Y;
  MoveToPtScr(PScr);
  OutTextXY(X,Y,S);
  IF Plot THEN
       BEGIN
        MoveToPtPlt(PPlt);
        Write(AUX, 'LB', S, Chr(3), ';');
       END;
  Plast := P;
  END;

{-----Transformations---------------------------------------------------------}

PROCEDURE ParameterTransformationScr;
VAR XScrL,YScrL: EXTENDED;
BEGIN
  WI2D[2].X := XL + WI2D[1].X;  WI2D[2].Y  :=  YL +  WI2D[1].Y;
  {XL:=WI2D[2].X-WI2D[1].X;    YL:=WI2D[2].Y-WI2D[1].Y;}
  XScrL:=IScr[2].X-IScr[1].X; YScrL:=IScr[1].Y-IScr[2].Y;
  IF (XL/YL<=XScrL/YScrL*ScrFac) THEN BEGIN
    ScrU.Y:=YScrL/YL;
    ScrU.X:=ScrU.Y/ScrFac;
    IScr2D[1].X:=IScr[1].X+TRUNC((XScrL-ScrU.X*XL)/2);
    IScr2D[1].Y:=IScr[1].Y;
    IScr2D[2].X:=IScr[2].X-TRUNC((XScrL-ScrU.X*XL)/2);
    IScr2D[2].Y:=IScr[2].Y;
  END ELSE BEGIN
    ScrU.X:=XScrL/XL;
    ScrU.Y:=ScrU.X*ScrFac;
    IScr2D[1].X:=IScr[1].X;
    IScr2D[1].Y:=IScr[1].Y-TRUNC((YScrL-ScrU.Y*YL)/2);
    IScr2D[2].X:=IScr[2].X;
    IScr2D[2].Y:=IScr[2].Y+TRUNC((YScrL-ScrU.Y*YL)/2);
  END;
  ScrO.X:=IScr2D[1].X+TRUNC(ScrU.X*(-WI2D[1].X));
  ScrO.Y:=IScr2D[1].Y-TRUNC(ScrU.Y*(-WI2D[1].Y));
END;

PROCEDURE ParameterTransformationPlt;
VAR XPltL,YPltL: EXTENDED;
BEGIN
  WI2D[2].X := XL + WI2D[1].X;  WI2D[2].Y  :=  YL +  WI2D[1].Y;
  {XL:=WI2D[2].X-WI2D[1].X;    YL:=WI2D[2].Y-WI2D[1].Y;}
  XPltL:=IPlt[2].X-IPlt[1].X;   YPltL:=IPlt[2].Y-IPlt[1].Y;
  IF (XL/YL<=XPltL/YPltL) THEN BEGIN
    PltU.Y:=YPltL/YL;
    PltU.X:=PltU.Y;
    IPlt2D[1].X:=IPlt[1].X+TRUNC((XPltL-PltU.X*XL)/2);
    IPlt2D[1].Y:=IPlt[1].Y;
    IPlt2D[2].X:=IPlt[2].X-TRUNC((XPltL-PltU.X*XL)/2);
    IPlt2D[2].Y:=IPlt[2].Y;
  END ELSE BEGIN
    PltU.X:=XPltL/XL;
    PltU.Y:=PltU.X;
    IPlt2D[1].X:=IPlt[1].X;
    IPlt2D[1].Y:=IPlt[1].Y+TRUNC((YPltL-PltU.Y*YL)/2);
    IPlt2D[2].X:=IPlt[2].X;
    IPlt2D[2].Y:=IPlt[2].Y-TRUNC((YPltL-PltU.Y*YL)/2);
  END;
  PltO.X:=IPlt2D[1].X+TRUNC(PltU.X*(-WI2D[1].X));
  PltO.Y:=IPlt2D[1].Y+TRUNC(PltU.Y*(-WI2D[1].Y));
END;

PROCEDURE Transformation(P: Pt2D; VAR PScr: PtScr; VAR PPlt: PtPlt);
BEGIN
  IF P.X < WI2D[1].X THEN P.X := WI2D[1].X;  (* Clipping in world !! *)
  IF P.X > WI2D[2].X THEN P.X := WI2D[2].X;
  IF P.Y < WI2D[1].Y THEN P.Y := WI2D[1].Y;
  IF P.Y > WI2D[2].Y THEN P.Y := WI2D[2].Y;

  PScr.X:= TRUNC(ScrO.X+ScrU.X*P.X+0.5);
  PScr.Y:= TRUNC(ScrO.Y-ScrU.Y*P.Y+0.5);
  IF Plot THEN BEGIN
    PPlt.X:= TRUNC(PltO.X+PltU.X*P.X); 
    PPlt.Y:= TRUNC(PltO.Y+PltU.Y*P.Y);
  END;
END;

PROCEDURE Parameter2D;
BEGIN
  ParameterTransformationScr;
  IF Plot THEN ParameterTransformationPlt;
END;


{-----2D-Points-----------------------------------------------------------}

PROCEDURE PutPt2D(P: Pt2D; Col: INTEGER);
VAR PScr: PtScr; PPlt: PtPlt;
BEGIN
  Transformation(P, PScr,PPlt);
  PutPixel(PScr.X,PScr.Y,Col);
  IF Plot THEN PutPtPlt(PPlt,Col);
  Plast := P;
END;

PROCEDURE MoveToPt2D(P: Pt2D);
VAR PScr: PtScr; PPlt: PtPlt;
BEGIN
  CsClip(P,P, Clipival,zeich);
  Transformation(P, PScr,PPlt);
  MoveToPtScr(PScr);
  IF Plot THEN MoveToPtPlt(PPlt);
  Plast := P;
  { DrawLine2D(Plast,P,GetBkColor); }
  Plast := P;
END;

PROCEDURE DrawToPt2D(P: Pt2D; Col: INTEGER);
  VAR PScr: PtScr; PPLt: PtPlt;
BEGIN
  CsClip(P,P, Clipival,zeich);
  Transformation(P, PScr,PPlt);
  DrawToPtScr(PScr,Col);
  IF Plot THEN DrawToPtPlt(PPLt,Col);
  Plast := P;
  {DrawLine2D(Plast,P,Col);}
END;

PROCEDURE DrawLine2D(P1:Pt2D;P2:Pt2D;Col:INTEGER);
VAR PScr1,PScr2: PtScr; PPLt1,PPlt2: PtPlt;
BEGIN
 CsClip(P1,P2, Clipival,zeich);
 Transformation(P1, PScr1,PPlt1);
 Transformation(P2, PScr2,PPlt2);
 IF Zeich THEN BEGIN
 SETCOLOR(Col);
 LINE(PScr1.X,PScr1.Y,PScr2.X,PScr2.Y);
 IF Plot THEN
   BEGIN
     MoveToPtPlt(PPlt1);
     DrawToPtPlt(PPlt2, Col);
   END;
 END;
 Plast := P2;
END;

PROCEDURE DrawInterval2D(I2D: Interval2D; Col: INTEGER);
VAR IScr: IntervalScr; IPlt: IntervalPlt;
BEGIN
  Transformation(I2D[1], IScr[1],IPlt[1]);
  Transformation(I2D[2], IScr[2],IPlt[2]);
  DrawIntervalScr(IScr,Col);
  IF Plot THEN DrawIntervalPlt(IPlt,Col);
END;

PROCEDURE MoveRel2D(V: Vt2D);
VAR
NewPt: Vt2D;
BEGIN
  NewPt.X := Plast.X + V.X;
  NewPt.Y := Plast.Y + V.Y;
  MoveToPt2D(NewPt);
  Plast := NewPt;
END;

PROCEDURE DrawRel2D(V: Vt2D;Col: INTEGER);
VAR
NewPt: Vt2D;
BEGIN
  NewPt.X := Plast.X + V.X;
  NewPt.Y := Plast.Y + V.Y;
  DrawToPt2D(NewPt,Col);
  Plast := NewPt;
END;

(* ---------------------- Initialisierungsteil -------------------------- *)
BEGIN
   Schnittstelle_waehlen(1);   (* parallele Schnittstelle                 *)
   Plot      := FALSE;         (* Plot = False bedeutet,dass der Plotter  *)
                               (* ausgeschaltet ist                       *)
   Portrait  := FALSE;         (* Hochformat oder liegendes Querformat ?  *)
                               (* True = stehendes senkrechtes Hochformat *)
                               (* False = liegendes breiteres Querformat  *)
   Plast.X := 0.0;             (* letzter Punkt im Ursprung               *)
   Plast.Y := 0.0;
END.
